/* sorgente: StrIO.c */

/* illustra le modalit di acquisizione e restituzione di una stringa */

/* inclusione del file di intestazione della libreria standard che
** contiene definizioni di macro, costanti e dichiarazioni di funzioni
** e tipi di interesse generale e funzionali alle varie operazioni di I/O */
#include <stdio.h>
#include <stdlib.h>

/* definizione della costante simbolica per la lunghezza massima di una stringa,
** '\0' escluso */
#define STR_LENGTH 80

/* chiamante */
int main ()
  {
  /* definizione delle due stringhe */
  char *Str1;
  char *Str2;
  
  /* allocazione della memoria per le due stringhe. Se l'allocazione
  ** ha esito negativo, recupera la memoria eventualmente allocata e termina */
  Str1 = (char *) malloc((STR_LENGTH+1)*sizeof(char));
	
  if (Str1 == NULL)
		return(0);
  
  Str2 = (char *) malloc((STR_LENGTH+1)*sizeof(char));
  
	if (Str2 == NULL)
		{
		free(Str1);
		return(0);
    };

  /* acquisizione delle due stringhe */
  printf("\nPrima Stringa? "); scanf("%s", Str1);
  printf("\nSeconda Stringa? "); scanf("%s", Str2);

  /* restituzione delle due stringhe */
  printf("\nPrima stringa: %s", Str1);
  printf("\nSeconda stringa: %s\n", Str2);
  
  /* recupero della memoria allocata per le stringhe */
  free(Str1);
  free(Str2);

  return(0);
  }
